# -*- coding: utf-8 -*-
"""Error_con_area.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1cvPH1fMJ2dRmT31ENaKGDaTW2wU_bt04
"""

from google.colab import drive
drive.mount('/content/drive')

import numpy as np

def DatosCurvasOrdenados(path):
  """"
  Función que recive los datos y los ordena talque  0<phi<2pi en orden creciente
  y 0<theta<2pi en orden creciente."""

  # se carga el txt
  datos = np.loadtxt(path,delimiter="\t",skiprows=2) # se eliminan los títulos
  # se crea un diccionario que permite ordenar los datos de 0<phi<2pi
  datos_vuelta = {0:[]}
  #primer ciclo
  n = 0
  for i in range(1,len(datos)):
    if datos[i-1,1] < datos[i,1]:
      # se apendan los datos que cumplen phi<2pi 
      datos_vuelta[n].append(datos[i-1])
    else:
      # si se pasa de vuelta se apenda phi<2pi y se crea una nueva entrada 
      # en el diccionario para guardar datos correspondientes a otra vuelta
      datos_vuelta[n].append(datos[i-1])
      n += 1
      datos_vuelta[n]=[]
  
  #segundo ciclo donde se ordena tal que 0<theta<2pi en orden creciente
  lista = []
  for i in range(len(datos_vuelta.keys())):
  #se apenda a la lista los valores de theta
  #y el número de llave del diccionario
    lista.append([datos_vuelta[i][0][2],i])
  #se ordenan de menor a mayor los valores de theta
  lista.sort(key = lambda x:x[0], reverse= False)
  # se genera una lista donde se guardan todos los datos ordenados
  datos_f = {}
  for i in range(len(datos_vuelta.keys())):
    datos_f[i]=datos_vuelta[lista[i][1]]
  return datos_f

def CurvasCartesianas(dnao):
  """
  Función que recive los datos ordenados y los pasa a coordenadas cartesianas
  """
  R0 = 0.2477
  carte = {}
  for i in range(len(dnao.keys())):
    carte[i]=[]
    for j in range(len(dnao[i])):
      Bmag = dnao[i][j][3] #magnitud campo magnético
      Bx = dnao[i][j][4] #componente en x del campo magnético
      By = dnao[i][j][5] #componente en y del campo magnético
      Bz = dnao[i][j][6] #componente en z del campo magnético
      R = R0+dnao[i][j][0]*np.cos(dnao[i][j][2])
      x = R*np.cos(dnao[i][j][1]) #componente en x del la partícula
      y = R*np.sin(dnao[i][j][1]) #componente en y del la partícula
      z = dnao[i][j][0]*np.sin(dnao[i][j][2]) #componente en z del la partícula
      cartesianas = [x,y,z,Bmag,Bx,By,Bz] #componentes en cartesianas
      carte[i].append(cartesianas)
    carte[i]=np.array(carte[i])
  return carte

def DatosFinales(path):
  """
  Función que recive el path de los datos y los ordena y transforma 
  a coordenadas cartesianas
  """
  dnao = DatosCurvasOrdenados(path)
  datos = CurvasCartesianas(dnao)
  l = len(datos)
  #se agrega una última curva idéntica a la primera,para poder iterar sobre
  #la última curva utilizando la primera como referencia.
  datos[l]= datos[0]
  return datos

def ErrorLocal(dnao):
  """
  Función que calcula el error local con datos ordenados y en coordenadas 
  cartesianas
  """
  l =len(dnao.keys())-1 # curvas a iterar para el error
  # se omite la última porque es idéntica a la primera. Esta
  # última curva sirve para para generar los vectores unitarios de la penúltima 
  # curva que en realidad es la última curva que da el BS-Soltrac

  error = {} # diccionario con error locales por curva 

  # Ciclo principal donde se calculan los errores locales de todas las curvas.
  for i in range(0,l):

    error[i]=[] #se analiza la i-ésima curva
    m = len(dnao[i+1])-1 #longitud de la i+1-ésima curva (con la que se compara)
    n = len(dnao[i])-1 #longitud de la i-ésima curva(donde se calcula el error)

    # se itera sobre cada punto de la curva i-ésima.
    for j in range(n):
      # condición cuando se tienen una relación 1:1 de puntos entre curvas
      if j<= m:
        dx1 = dnao[i][j+1][0]-dnao[i][j][0] #dx curva i-ésima 
        dy1 = dnao[i][j+1][1]-dnao[i][j][1] #dy curva i-ésima 
        dz1 = dnao[i][j+1][2]-dnao[i][j][2] #dz curva i-ésima 
        r1_j = np.array([dx1,dy1,dz1]) #r curva i-ésima

        dx2 = dnao[i+1][j][0]-dnao[i][j][0] #dx curva i+1-ésima 
        dy2 = dnao[i+1][j][1]-dnao[i][j][1] #dy curva i+1-ésima 
        dz2 = dnao[i+1][j][2]-dnao[i][j][2] #dz curva i+1-ésima 
        r2_j = np.array([dx2,dy2,dz2]) #r curva i+1-ésima

        N = np.cross(r1_j,r2_j) #producto cruz entre r_i-ésima y r_i+1-ésima
        dA = np.sqrt(np.dot(N,N)) #área paralelogramo entre los r's
        n = N/dA #vector unitario en dirección perpendicular a las dos curvas

        Bmag = dnao[i][j][3] #magnitud campo magnético
        Bx_j = dnao[i][j][4] #componente en x del campo magnético en curva i
        By_j = dnao[i][j][5] #componente en y del campo magnético en curva i
        Bz_j = dnao[i][j][6] #componente en z del campo magnético en curva i
        B = np.array([Bx_j,By_j,Bz_j]) #campo magnético en curva i-ésima 

        e_j = abs(np.dot(B,n))/Bmag # error local en el punto de anális 
        error[i].append([e_j,dA])
      
      #caso donde la curva i+1 tiene menos puntos que la curva i 
      else:
        dx1 = dnao[i][j+1][0]-dnao[i][j][0] #dx curva i-ésima
        dy1 = dnao[i][j+1][1]-dnao[i][j][1] #dy curva i-ésima
        dz1 = dnao[i][j+1][2]-dnao[i][j][2] #dz curva i-ésima 
        r1_j = np.array([dx1,dy1,dz1]) #r curva i-ésima

        # se utiliza el último punto de la curva i+1
        dx2 = dnao[i+1][m][0]-dnao[i][j][0] #dx curva i+1-ésima
        dy2 = dnao[i+1][m][1]-dnao[i][j][1] #dy curva i+1-ésima
        dz2 = dnao[i+1][m][2]-dnao[i][j][2] #dz curva i+1-ésima
        r2_j = np.array([dx2,dy2,dz2]) #r curva i+1-ésima

        N = np.cross(r1_j,r2_j) #producto cruz entre r_i-ésima y r_i+1-ésima
        dA = np.sqrt(np.dot(N,N)) ##área paralelogramo entre los r's
        n = N/dA #vector unitario en dirección perpendicular a las dos curvas

        Bmag = dnao[i][j][3] #magnitud campo magnético
        Bx_j = dnao[i][j][4] #componente en x del campo magnético en curva i
        By_j = dnao[i][j][5] #componente en y del campo magnético en curva i
        Bz_j = dnao[i][j][6] #componente en j del campo magnético en curva i
        B = np.array([Bx_j,By_j,Bz_j])#campo magnético en curva i-ésima 

        e_j = abs(np.dot(B,n))/Bmag # error local en el punto de anális
        error[i].append([e_j,dA])

  return error

def Coordenadas_RZ(array,angulo):
  """
  Función que recive los datos ordenados y los pasa a coordenadas [R,z] 
  """
  R0 = 0.2477
  cartesianas = []
  for i in range(len(array)):
    R = R0+array[i][0]*np.cos(array[i][2])
    z = array[i][0]*np.sin(array[i][2])
    cartesianas.append([R,z])
  return np.array(cartesianas)

def Perimetro(datos,angulo,dphi):
  """
  Función que calcula el perímetro para un corte (phi= constante)
  """
  #Primero se seleciona un pequeño diferencial dphi para crear un corte
  dphi = dphi*np.pi/180
  angulo_rad = angulo*np.pi/180
  phi_up = angulo_rad + dphi/2
  phi_down = angulo_rad - dphi/2  
  R0 = 0.2477 #Radio característico del SCR-1
  # se opera sobre los datos ordenados para crear el corte
  corte = []
  for i in range(len(datos.keys())):
    for j in range(len(datos[i])):
      if datos[i][j][1] > phi_down and datos[i][j][1] < phi_up:
       corte.append([datos[i][j][0],datos[i][j][1],datos[i][j][2]])
  # se ordenan los datos para que la curva a la que se le va a calcular el perímetro sea suave
  corte.sort(key = lambda x:x[2], reverse= False)
  corte = np.array(corte)
  corte = Coordenadas_RZ(corte,angulo)
  # se calcula el perímetro
  ds = 0
  for i in range(1,len(corte)):
    dr2 = (corte[i][0]-corte[i-1][0])**2
    dz2 = (corte[i][1]-corte[i-1][1])**2
    ds += np.sqrt(dr2+dz2)
  return ds

def AreaEnvolvente(archivo,dphi_corte,phi_revolucion):
  """
  Función que calcula el el área envolvente de una path siguiendo el teorema de 
  Pappus-Guldin
  """
  angulo = 0
  area = 0
  iter = int(np.round(360/phi_revolucion))
  phi_revolucion_rad = phi_revolucion*np.pi/180
  R0 = 0.2477
  datos = DatosCurvasOrdenados(archivo)
  for i in range(iter):
    p = Perimetro(datos,angulo,dphi_corte)
    area += phi_revolucion_rad*R0*p 
    angulo += phi_revolucion
  return area

def ErrorSup(dnao,area):
  """
  Función que da el error promedio en una superficie que cumpe JxB=nabla_p
  """
  # primero se calcula la cantidad de puntos en la superficie
  cantidad_puntos = 0
  for i in range(len(dnao.keys())):
    cantidad_puntos += len(dnao[i])
  A = area #área envolvente
  n = cantidad_puntos #número de puntos en la superficie
  dA = A/n #diferencial de área
  error_dA = 0 #suma del error por diferencial de área
  for i in range(len(dnao.keys())):
    for j in range(len(dnao[i])):
      error_dA += dnao[i][j][0]*dA #se suman todas las contribuciones al error
  error_dA_sup = error_dA/A #error promedio de la superficie
  return error_dA_sup

###############################################################################
t_path = "/content/drive/MyDrive/Codes/Datos/resultadosFinales/torpath0029.txt"
dphi_corte, phi_revolucion = 0.5,1
area_t_path = AreaEnvolvente(t_path,dphi_corte,phi_revolucion)
datos = DatosFinales(t_path)
error = ErrorLocal(datos)
print(ErrorSup(error,area_t_path))